﻿Imports System
Imports System.Collections.Generic
Imports System.ComponentModel
Imports System.Drawing
Imports System.IO
Imports System.Threading
Imports System.Windows.Forms
Imports TvControl
Imports TvDatabase
Imports TvLibrary.Channels
Imports TvLibrary.Interfaces
Imports TvLibrary.Log

Public Class PIDbuffer

    Public buffer As Byte() = New Byte(&H1000 - 1) {}
    Public buffer_position As Integer
    Public continuity_counter As Integer
    Public currently_parsing As Boolean
    Public section_length As Integer
    Public table_id As Integer

End Class

Public Class CustomDataGRabber

    Private _channel As Channel
    Private _card As VirtualCard
    Private packetbuffer As Byte()
    Private Complete As Boolean = False
    Private TSBuffer As Byte()
    Private TStream As IO.BinaryReader
    Private WantedPIDS As New List(Of Integer)
    Private TimeStamp As DateTime
    Private Errorcodesent As Integer = 0
    Private Decoders As New List(Of Integer)

    Public Sub SendComplete(ByVal ErrorCode As Integer)
        Errorcodesent = ErrorCode
        Complete = True
    End Sub

    Public Sub GrabData(ByVal ChannelID As Integer, ByVal Seconds As Integer, ByVal Pids As List(Of Integer))
        If Decoders.Contains(ChannelID) = False Then
            Dim thread1 As New Thread(AddressOf GrabData1)
            Dim params(3) As Object
            params(0) = ChannelID
            params(1) = Seconds
            params(2) = Pids
            Decoders.Add(ChannelID)
            thread1.Start(params)
        Else
            RaiseEvent OnComplete(True, "Already grabbing on this channel, try again later")
        End If
    End Sub

    Public Sub GrabData1(ByVal ChannelID1() As Object)
        Dim ChannelID As Integer = ChannelID1(0)
        Dim Seconds As Integer = ChannelID1(1)
        Dim Pids As List(Of Integer) = ChannelID1(2)
        Dim Filename As String = "Custom_" + ChannelID.ToString + ".ts"
        Complete = False
        Dim server As TvServer = New TvServer
        Dim user As IUser = New User(Filename, False)
        WantedPIDS = Pids
        Dim result As TvResult = server.StartTimeShiftingWithCustom(user, ChannelID, _card, Filename, Pids)
        If (result = TvResult.Succeeded) Then
            Dim NewFile As String = _card.TimeshiftFolder + "\" + Filename
            TimeStamp = Now.AddSeconds(Seconds)
            ProcessPackets(NewFile)
            Decoders.Remove(ChannelID)
        Else
            Decoders.Remove(ChannelID)
            RaiseEvent OnComplete(True, result.ToString)
        End If

    End Sub

    Public Sub NewSectionHandler(ByVal pid As Integer, ByVal Length As Integer, ByVal section As Section)
        RaiseEvent OnPacket(pid, Length, section)
    End Sub


    Sub ProcessPackets(ByVal Filename As String)
        ' Try
        Dim Filestream As New FileStream(Filename, System.IO.FileMode.Open, System.IO.FileAccess.Read, System.IO.FileShare.ReadWrite, 8000, True)
        Dim BinaryReader As New BinaryReader(Filestream)

        Dim a As Integer
        Do Until Filestream.Length > 5000
            a += 1
            Thread.Sleep(500)
            If a > 100 Then
                Log.Write("Not Enough Data to process")
                RaiseEvent OnComplete(True, "Not Enough Data to process")
                Exit Sub
            End If
        Loop
        a = 0
        Dim wait As Boolean = False
        Do While Complete = False
            Dim sync(3) As Byte
            Dim syncloop As Integer = 0

            Do Until Filestream.Position + 3 < Filestream.Length
                syncloop += 1
                If wait = False Then
                    wait = True
                    Log.Write("Waiting for Custom data file to reach correct size")
                End If
                wait = False
                Thread.Sleep(1000)
                If syncloop > 10 Then
                    GoTo error1
                End If
            Loop
            syncloop = 0
            sync = BinaryReader.ReadBytes(3)
            If sync.Length > 2 Then
                If sync(0) = &HFF And sync(1) = &HAA And sync(2) = &HFF Then
gotsync:

                    If Complete Then Exit Do
                    Dim pida() As Byte

                    Do Until Filestream.Position + 2 < Filestream.Length
                        syncloop += 1
                        If wait = False Then
                            wait = True
                            Log.Write("Waiting for Custom data file to reach correct size")
                        End If
                        wait = False
                        Thread.Sleep(1000)
                        If syncloop > 10 Then
                            GoTo error1
                        End If
                    Loop
                    syncloop = 0
                    pida = BinaryReader.ReadBytes(2)
                    Dim pid As Integer
                    pid = (pida(0) * (2 ^ 8)) + pida(1)
                    Dim lengtha() As Byte
                    Do Until Filestream.Position + 2 < Filestream.Length
                        syncloop += 1
                        If wait = False Then
                            wait = True
                            Log.Write("Waiting for Custom data file to reach correct size")
                        End If
                        wait = False
                        Thread.Sleep(1000)
                        If syncloop > 10 Then
                            GoTo error1
                        End If
                    Loop
                    syncloop = 0
                    lengtha = BinaryReader.ReadBytes(2)
                    Do Until Filestream.Position < Filestream.Length
                        syncloop += 1
                        If wait = False Then
                            wait = True
                            Log.Write("Waiting for Custom data file to reach correct size")
                        End If
                        wait = False
                        Thread.Sleep(1000)
                        If syncloop > 10 Then
                            GoTo error1
                        End If
                    Loop
                    Dim sectionnum As Integer = Convert.ToInt32(BinaryReader.ReadByte)
                    Dim length As Integer
                    length = ((lengtha(0) And &HF) * (2 ^ 8)) + lengtha(1)
                    Dim section As New Section()
                    syncloop = 0
                    Do Until Filestream.Position + length + 5 < Filestream.Length
                        syncloop += 1
                        If wait = False Then
                            wait = True
                            Log.Write("Waiting for Custom data file to reach correct size")
                        End If
                        wait = False
                        Thread.Sleep(1000)
                        If syncloop > 10 Then
                            GoTo error1
                        End If
                    Loop
                    section.Data = BinaryReader.ReadBytes(length + 5)
                    If section.Data.Length > 0 Then
                        section.table_id = section.Data(0)
                        section.section_number = sectionnum
                        section.section_length = length
                        RaiseEvent OnPacket(pid, length, section)
                    End If
                Else
                    Log.Write("Lost Sync to data finding it ...")
                    syncloop = 0
Tryagain:
                    If Complete Then Exit Do
                    syncloop += 1
                    If syncloop > 1000 Then
                        RaiseEvent OnComplete(True, "File Sync could not be recovered")
                        Exit Do
                    End If
                    syncloop = 0
                    Do Until Filestream.Position < Filestream.Length
                        syncloop += 1
                        If wait = False Then
                            wait = True
                            Log.Write("Waiting for Custom data file to reach correct size")
                        End If
                        Thread.Sleep(1000)
                        wait = False
                        If syncloop > 10 Then
                            GoTo error1
                        End If
                    Loop
                    Dim first, second, third As Byte
                    first = BinaryReader.ReadByte
                    If first <> &HFF Then GoTo Tryagain
                    syncloop = 0
                    Do Until Filestream.Position < Filestream.Length
                        syncloop += 1
                        If wait = False Then
                            wait = True
                            Log.Write("Waiting for Custom data file to reach correct size")
                        End If
                        Thread.Sleep(1000)
                        wait = False
                        If syncloop > 10 Then
                            GoTo error1
                        End If
                    Loop
                    second = BinaryReader.ReadByte
                    If second <> &HAA Then GoTo Tryagain
                    syncloop = 0
                    Do Until Filestream.Position < Filestream.Length
                        syncloop += 1
                        If wait = False Then
                            wait = True
                            Log.Write("Waiting for Custom data file to reach correct size")
                        End If
                        Thread.Sleep(1000)
                        wait = False
                        If syncloop > 10 Then
                            GoTo error1
                        End If
                    Loop
                    third = BinaryReader.ReadByte
                    If third <> &HFF Then GoTo Tryagain
                    Log.Write("File back in sync continuing grab")
                    GoTo gotsync
                End If
            End If
            If Now > TimeStamp Then Exit Do
        Loop
        Log.Write("Stopping Timeshift as Complete was received")
        GoTo over

error1:
        Log.Write("Stream isn't being written to .. Stopping")
        RaiseEvent OnComplete(True, "Datastream isn't being written to. Stopping")
        Errorcodesent = 1
over:

        Complete = False
        _card.StopTimeShifting()
        BinaryReader.Close()
        Filestream.Close()
        System.IO.File.Delete(Filename)
        If Errorcodesent = 0 Then
            RaiseEvent OnComplete(False, "")
        End If
    End Sub

    Public Event OnPacket(ByVal Pid As Integer, ByVal Length As Integer, ByVal Data As Section)
    Public Event OnComplete(ByVal Err As Boolean, ByVal ErrorMessage As String)

    Protected Overrides Sub Finalize()
        MyBase.Finalize()
    End Sub
End Class

Public Class Section

    Public table_id As Integer
    Public table_id_extention As Integer
    Public section_length As Integer
    Public section_number As Integer
    Public last_section_number As Integer
    Public version_number As Integer
    Public section_syntax_indicator As Integer
    Public BufferPos As Integer
    Public Data() As Byte

    Public Sub Reset()
        table_id = -1
        table_id_extention = -1
        section_length = -1
        section_number = -1
        version_number = -1
        section_syntax_indicator = -1
        BufferPos = 0
    End Sub

    Function CalcSectionLength(ByVal tsPacket As Byte(), ByVal start As Integer) As Integer

        If BufferPos < 3 Then
            Dim bHi As Byte = 0
            Dim bLo As Byte = 0
            If BufferPos = 1 Then
                bHi = tsPacket(start)
                bLo = tsPacket(start + 1)
            ElseIf BufferPos = 2 Then
                bHi = Data(1)
                bLo = tsPacket(start)
            End If
            section_length = ((bHi And &HF) * (2 ^ 8)) + bLo
        Else
            section_length = ((Data(1) And &HF) * (2 ^ 8)) + Data(2)
        End If

        Return section_length

    End Function

    Function DecodeHeader() As Boolean
        If BufferPos < 8 Then Return False
        table_id = Data(0)
        section_syntax_indicator = (Data(1) / (2 ^ 7)) And 1
        If (section_length = -1) Then
            section_length = ((Data(1) And &HF) * (2 ^ 8)) + Data(2)
        End If
        table_id_extention = (Data(3) * (2 ^ 8)) + Data(4)
        version_number = (Data(5) / (2 ^ 1)) And &H1F
        section_number = Data(6)
        section_syntax_indicator = (Data(1) / (2 ^ 7)) And 1
        Return True
    End Function

    Function SectionComplete() As Boolean
        If Not DecodeHeader() And ((BufferPos - 3) > section_length) And (section_length > 0) Then
            Return True
        End If
        If Not DecodeHeader() Then
            Return False
        End If
        Return ((BufferPos - 3) >= section_length)
    End Function


End Class


